
void _efl_composite_model_index_set(Eo *obj, Efl_Composite_Model_Data *pd, unsigned int index);


static Eina_Error
__eolian_efl_composite_model_index_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   unsigned int cval;
   if (!eina_value_uint_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_composite_model_index_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_composite_model_index_set, EFL_FUNC_CALL(index), unsigned int index);

unsigned int _efl_composite_model_index_get(const Eo *obj, Efl_Composite_Model_Data *pd);


static Eina_Value
__eolian_efl_composite_model_index_get_reflect(const Eo *obj)
{
   unsigned int val = efl_composite_model_index_get(obj);
   return eina_value_uint_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_composite_model_index_get, unsigned int, 0);

void _efl_composite_model_efl_object_destructor(Eo *obj, Efl_Composite_Model_Data *pd);


void _efl_composite_model_efl_object_invalidate(Eo *obj, Efl_Composite_Model_Data *pd);


Efl_Object *_efl_composite_model_efl_object_finalize(Eo *obj, Efl_Composite_Model_Data *pd);


void _efl_composite_model_efl_ui_view_model_set(Eo *obj, Efl_Composite_Model_Data *pd, Efl_Model *model);


Efl_Model *_efl_composite_model_efl_ui_view_model_get(const Eo *obj, Efl_Composite_Model_Data *pd);


Eina_Future *_efl_composite_model_efl_model_property_set(Eo *obj, Efl_Composite_Model_Data *pd, const char *property, Eina_Value *value);


Eina_Value *_efl_composite_model_efl_model_property_get(const Eo *obj, Efl_Composite_Model_Data *pd, const char *property);


Eina_Iterator *_efl_composite_model_efl_model_properties_get(const Eo *obj, Efl_Composite_Model_Data *pd);


unsigned int _efl_composite_model_efl_model_children_count_get(const Eo *obj, Efl_Composite_Model_Data *pd);


Eina_Future *_efl_composite_model_efl_model_children_slice_get(Eo *obj, Efl_Composite_Model_Data *pd, unsigned int start, unsigned int count);


Efl_Object *_efl_composite_model_efl_model_child_add(Eo *obj, Efl_Composite_Model_Data *pd);


void _efl_composite_model_efl_model_child_del(Eo *obj, Efl_Composite_Model_Data *pd, Efl_Object *child);


static Eina_Bool
_efl_composite_model_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_COMPOSITE_MODEL_EXTRA_OPS
#define EFL_COMPOSITE_MODEL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_composite_model_index_set, _efl_composite_model_index_set),
      EFL_OBJECT_OP_FUNC(efl_composite_model_index_get, _efl_composite_model_index_get),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_composite_model_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_composite_model_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_composite_model_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_ui_view_model_set, _efl_composite_model_efl_ui_view_model_set),
      EFL_OBJECT_OP_FUNC(efl_ui_view_model_get, _efl_composite_model_efl_ui_view_model_get),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, _efl_composite_model_efl_model_property_set),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, _efl_composite_model_efl_model_property_get),
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, _efl_composite_model_efl_model_properties_get),
      EFL_OBJECT_OP_FUNC(efl_model_children_count_get, _efl_composite_model_efl_model_children_count_get),
      EFL_OBJECT_OP_FUNC(efl_model_children_slice_get, _efl_composite_model_efl_model_children_slice_get),
      EFL_OBJECT_OP_FUNC(efl_model_child_add, _efl_composite_model_efl_model_child_add),
      EFL_OBJECT_OP_FUNC(efl_model_child_del, _efl_composite_model_efl_model_child_del),
      EFL_COMPOSITE_MODEL_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"index", __eolian_efl_composite_model_index_set_reflect, __eolian_efl_composite_model_index_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_composite_model_class_desc = {
   EO_VERSION,
   "Efl.Composite_Model",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Composite_Model_Data),
   _efl_composite_model_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_composite_model_class_get, &_efl_composite_model_class_desc, EFL_LOOP_MODEL_CLASS, EFL_UI_VIEW_INTERFACE, NULL);
